<?php
/**
*FUNCTIONS ARE DECLARED HERE 
*/

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die( 'Restricted access' );

/* Import library dependencies */
jimport('joomla.event.plugin');
  
  
class mod_LDBChecker extends JPlugin  
{  
  //This functions gets the last backup's date
  public static function getLastDate($checkfileFolder)
	{
	  $parametersStats = null;
    //opens the directory in which is the lazydbbackup_checkfile
    $handle = @opendir($checkfileFolder); 
    
    //searching the file
    while($file = @readdir($handle)) 
    {
	  //searching the lazydbbackup_checkfile file
      if(preg_match("/lazydbbackup_checkfile/", $file))  
      {        
        //Reads informations in lazydbbackup_checkfile
        $parametersStats = stat($checkfileFolder.DIRECTORY_SEPARATOR.$file);
      }
    }

    @closedir($handle);
    //returns the mtime (time in days) 
		return $parametersStats[9];
	}
  
  //This function counts backups
	public static function getNbBackups($path)
	{
    $cpt = 0;
    // 15/05/2013
	$foldermedia = str_replace("/", "", $path);
    if((empty($path)) || ($foldermedia=="media"))
	//if(empty($path))
    {
      $path = JPATH_ROOT.DIRECTORY_SEPARATOR."media".DIRECTORY_SEPARATOR;
    }
    
    //opens the directory in which we are counting
    if($handle = @opendir($path))
    {
      //counting the files
      while($file = @readdir($handle)) 
      {
        //counting only the .sql.gz files
        if(preg_match("/.sql.gz/", $file)) 
        {        
          $cpt ++;
        }
      }
  
      @closedir($handle);
      
      return $cpt;
    }
    else
    {
      return JTEXT::_('LDBC_INVALIDFOLDER').$path.'::'.JPATH_ROOT;
    }
	}
	
	//This function gets the last backup's date
  public static function getLastBackupDate($checkfileFolder, $nbBackup, $nbDays)
	{

    //if(!preg_match("/0/",$nbBackup))
	if (!($nbBackup = 0))
    { 
      if($lastDate = mod_LDBChecker::getLastDate($checkfileFolder))
      {
        //Search number of days
        $todayTime = floor(time() / ( 3600*24));
  	    $lastDateDays = floor($lastDate / (3600*24));
	   
        //if there is not too many days passed by
        if($todayTime-$lastDateDays < $nbDays + 1)
  	    {
          //return "<span style='color: green'>".date(JText::_('DATE_FORMAT_LC4'), $lastDate)."</div>";
          return "<span style='color: green'>".JHTML::_('date', $lastDate, JText::_('DATE_FORMAT_LC4'))."</span>";
        }
        else
        {
          //return "<span style='color: red'>".date(JText::_('DATE_FORMAT_LC4'), $lastDate)."</div>";
          return "<span style='color: red'>".JHTML::_('date', $lastDate, JText::_('DATE_FORMAT_LC4'))."</span>";
        }
      }
      else
      {
        return JTEXT::_('LDBC_FAIL')." ".$lastDate;
      }
    }
    else
    {
      
      $handle = @opendir($checkfileFolder); 
    
      //searching the lazybackup_checkfile file to delete it
      while($file = @readdir($handle)) 
      {
        if(preg_match("/lazydbbackup_checkfile/", $file))
        {
          unlink($checkfileFolder.DIRECTORY_SEPARATOR.$file);
        }
      }
  
      @closedir($handle);
      
      return "<span style='color:red'>".JTEXT::_('LDBC_NOBACKUP')."</span>";
    }
	}
	
  //This function deletes the olds backups
  public static function delOldBackups($backuppath, $nbToKeep)
	{
	   $nbBackups = mod_LDBChecker::getNbBackups($backuppath);
	   
     //if there is more backups than backups to keep parameter
     if($nbBackups > $nbToKeep)
	   {
        //then delete the olders ones
	      $mTimeBackup = array();
        $nbToDelete = $nbBackups - $nbToKeep;
        $parametersStats = null;
        //opens the directory in which are the lazydbbackup_checkfile file
        $handle = @opendir($backuppath); 
        
        $cpt = 0;
        //looking in the folder
        while($file = @readdir($handle)) 
        {
          //searching the lazydbbackup_checkfile file
          if(preg_match("/.sql.gz/", $file))
          {        
            //Reads informations in lazydbbackup_checkfile
            $parametersStats = stat($backuppath.DIRECTORY_SEPARATOR.$file);
            $mTimeBackup[$cpt] = $parametersStats[9];
            $cpt++;
          }
        }
        @closedir($handle);
        
        
        //Sort from older to newer
        sort($mTimeBackup, SORT_NUMERIC);
        
        $cpt = 0;

        while($cpt < $nbToDelete )
        {
            //opens the directory in which are the backup
            $handle = @opendir($backuppath); 
            while($file = @readdir($handle)) 
            {
                $fileStats = stat($backuppath.DIRECTORY_SEPARATOR.$file);
                //searching the lazydbbackup_checkfile file
                if($mTimeBackup[$cpt] == $fileStats[9])
                {        
                    unlink($backuppath.DIRECTORY_SEPARATOR.$file);
                    echo $file." ".JTEXT::_('LDBC_REMOVED')."<br/>";
                }
            }
                     
            $cpt ++;
        }

        @closedir($handle);
	   }

  }	
}